using System;

namespace Upsilon.Text
{
    public class SourceText
    {
        private readonly string _text;

        public SourceText(string text)
        {
            _text = text;
        }

        public string GetSpan(int start, int length)
        {
            if (start < 0)
            {
                length += start;
                start = 0;
            };
            if (start >= _text.Length)
                return string.Empty;
            if (start + length >= _text.Length) length = _text.Length - start;
            return _text.Substring(start, length);
        }

        public string GetSpan(TextSpan span)
        {
            return GetSpan(span.Start, span.Length);
        }
    }
}